
volatile u32 tim0,tim1,tim2;

extern "C"
{
 void SysTick_Handler()
 {
  if(tim0)tim0--;
  if(tim1)tim1--;
  if(tim2)tim2--;

  static bool trg;
  trg^=1;
  if(trg) kb_state = kb_scan();


 }

 void EXTI4_15_IRQHandler()
 {
  tim0 = 1000;
  NVIC_DisableIRQ(EXTI0_1_IRQn);
  NVIC_DisableIRQ(EXTI4_15_IRQn);

  EXTI_ClearFlag(EXTI_Line1|EXTI_Line6|EXTI_Line7|EXTI_Line9|EXTI_Line10);
 }

 void EXTI0_1_IRQHandler()
 {
  tim0 = 1000;
  NVIC_DisableIRQ(EXTI0_1_IRQn);
  NVIC_DisableIRQ(EXTI4_15_IRQn);

  EXTI_ClearFlag(EXTI_Line1|EXTI_Line6|EXTI_Line7|EXTI_Line9|EXTI_Line10);
 }
//-----------------------------------

 void TIM2_IRQHandler()
 {
  #define MAX_PULSE 4000 //us
  #define MIN_PULSE 100  //us
  #define MAX_PRD   5000 //us
  #define MIN_PRD   500  //us


  u32 tmp    = TIM2->SR;
  TIM2->CR1  = TIM_CR1_CEN;
  int pulse  = TIM2->CCR1;//>>2;
  int period = TIM2->CCR2;//>>2;

  //      
  static int im=0;
  bool reset_proc = false;

  //         
  if((tmp & TIM_SR_UIF) && !(tmp & TIM_SR_TIF))
  {
   //       
   //  
   if(im < 16) reset_proc = true;
   //       
   //     .
   else
   {
    if(im < szm-2)
    {
     mss_rcvd[im++] = (u16)-1;
     mss_rcvd[im++] = pulse;
    }

    rcvd_ready = true;
    im = 0;

    TIM2->DIER = 0;
    TIM2->CR1  = 0;
   }
  }
  else
  {
   //      
   if(!(TIM2->DIER & TIM_DIER_UIE)) TIM2->DIER = TIM_DIER_TIE | TIM_DIER_UIE;
   //     
   else if(pulse < MIN_PULSE || period < MIN_PRD) reset_proc = true;
//   else if(im > 3 && pulse > MAX_PULSE)           reset_proc = true;
   else
   {
    //    
    if(im > szm-2) reset_proc = true;
    //     
    else
    {
     mss_rcvd[im++] = period;
     mss_rcvd[im++] = pulse;
    }
   }
  }

  //   
  if(reset_proc == true)
  {
   im = 0;
   clear_rcvd();
   TIM2->DIER = TIM_DIER_TIE;
   TIM2->CR1  = 0;
  }


  TIM2->SR = 0;
  __DSB();
 }

//-----------------------------------

 void TIM16_IRQHandler()
 {
  TIM16->SR = 0;
  __DSB();
 }

//-----------------------------------

 void HardFault_Handler()
 {

  while(1)
  {
   static volatile int k=0;
   static bool trg;

   if(k)k--;
   else
   {
    trg ^=1;
    k = 0xfffff;

    if(trg)led(true);
    else   led(false);
   }
  }
 }

 void NMI_Handler()
 {

  while(1)__no_operation();
 }

 void Default_Handler()
 {

  while(1)__no_operation();
 }
}



//   Reset_Handler                  ; Reset Handler
//
//   NMI_Handler                    ; NMI Handler
//   HardFault_Handler              ; Hard Fault Handler
//   PendSV_Handler                 ; PendSV Handler
//   SysTick_Handler                ; SysTick Handler
//
//  ; External Interrupts
//   WWDG_IRQHandler                ; Window Watchdog
//   PVD_IRQHandler                 ; PVD through EXTI Line detect
//   RTC_IRQHandler                 ; RTC through EXTI Line
//   FLASH_IRQHandler               ; FLASH
//   RCC_IRQHandler                 ; RCC
//   EXTI0_1_IRQHandler             ; EXTI Line 0 and 1
//   EXTI2_3_IRQHandler             ; EXTI Line 2 and 3
//   EXTI4_15_IRQHandler            ; EXTI Line 4 to 15
//   TS_IRQHandler                  ; TS
//   DMA1_Channel1_IRQHandler       ; DMA1 Channel 1
//   DMA1_Channel2_3_IRQHandler     ; DMA1 Channel 2 and Channel 3
//   DMA1_Channel4_5_IRQHandler     ; DMA1 Channel 4 and Channel 5
//   ADC1_COMP_IRQHandler           ; ADC1, COMP1 and COMP2
//   TIM1_BRK_UP_TRG_COM_IRQHandler ; TIM1 Break, Update, Trigger and Commutation
//   TIM1_CC_IRQHandler             ; TIM1 Capture Compare
//   TIM2_IRQHandler                ; TIM2
//   TIM3_IRQHandler                ; TIM3
//   TIM6_DAC_IRQHandler            ; TIM6 and DAC
//   0                              ; Reserved
//   TIM14_IRQHandler               ; TIM14
//   TIM15_IRQHandler               ; TIM15
//   TIM16_IRQHandler               ; TIM16
//   TIM17_IRQHandler               ; TIM17
//   I2C1_IRQHandler                ; I2C1
//   I2C2_IRQHandler                ; I2C2
//   SPI1_IRQHandler                ; SPI1
//   SPI2_IRQHandler                ; SPI2
//   USART1_IRQHandler              ; USART1
//   USART2_IRQHandler              ; USART2
//   0                              ; Reserved
//   CEC_IRQHandler                 ; CEC
//   0                              ; Reserved

